require "conf_encrypt/version"
require 'yaml'

module ConfEncrypt
  def self.config
    @config ||= YAML.load_file('.conf_encrypt.yml') rescue {}
  end

  def self.path
    config[:path] || ENV['CONF_ENCRYPT_PATH']
  end

  def self.file_name
    config[:file_name] || ENV['CONF_ENCRYPT_FILE_NAME']
  end

  def self.password
    config[:password] || ENV['CONF_ENCRYPT_PASSWORD']
  end

  def self.tar_file_name
    'encrypt_tmp.tar'
  end

  def self.encrypt
    system("tar cvf #{tar_file_name} #{path}")
    system("openssl aes-256-cbc -salt -in #{tar_file_name} -out #{file_name} -k #{password}")
    system("rm #{tar_file_name}")
  end

  def self.decrypt
    system("openssl aes-256-cbc -d -salt -in #{file_name} -out #{tar_file_name} -k #{password}")
    system("tar -xvf #{tar_file_name}")
    system("rm #{tar_file_name}")
  end
end
